#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <util/delay.h>

#define bit_set(port,bit)       { port |= (1<<(bit));}
#define bit_clear(port,bit)     { port &= ~(1<<(bit));}
#define min(a,b)                ((a)<(b) ? (a):(b))

#define nop()   __asm__ volatile ("nop" )
#define wdr()   __asm__ volatile("wdr" )

ISR(INT0_vect) {
	bit_clear(PORTC, PC2);
}

//#if defined (__RTAVR_rtavr40__)

int main() {
	MCUCR = (3 << ISC00); // posedge
	bit_clear(PORTC, PC2);
	bit_set(DDRC, PC2);
	bit_set(GIFR,INTF0);
	bit_set(GIMSK,INT0);
	sei();

	nop();
	bit_set(PORTC, PC2);
	PINC;
	PINC;
	bit_set(PORTC, PC2);
	nop();
	nop();
	return 0;
}
