#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <util/delay.h>

#define bit_set(port,bit)       { port |= (1<<(bit));}
#define bit_clear(port,bit)     { port &= ~(1<<(bit));}
#define min(a,b)                ((a)<(b) ? (a):(b))

#define nop()   __asm__ volatile ("nop" )
#define wdr()   __asm__ volatile("wdr" )
#define sleep()   __asm__ volatile("sleep" )

ISR(INT0_vect) {
	bit_clear(PORTC, PC2);
}

extern void shuffle_init(int16_t *);
extern void shuffle(int16_t *);
int main() {
	int8_t i;
	int16_t state[9];

	MCUCR = (3 << ISC00); // posedge
	bit_clear(PORTC, PC2);
	bit_set(DDRC, PC2);
	bit_set(GIFR,INTF0);
	bit_set(GIMSK,INT0);
	sei();

	shuffle_init(state);

	for (i=0; i< 100; i++) { 
		shuffle(state);
#if 0
		bit_set(PORTC, PC2);
#else
		nop();
#endif
		nop();
		nop();
		nop();
#if 0
		nop();
#else
		sleep();
#endif
	}
	return 0;
}
