#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <util/delay.h>

#define bit_set(port,bit)       { port |= (1<<(bit));}
#define bit_clear(port,bit)     { port &= ~(1<<(bit));}
#define min(a,b)                ((a)<(b) ? (a):(b))

#define nop()   __asm__ volatile ("nop" )
#define wdr()   __asm__ volatile("wdr" )
#define sleep()   __asm__ volatile("sleep" )


uint8_t t_skip1a(uint8_t a, uint8_t *p);
uint8_t t_skip1b(uint8_t a, uint8_t *p);
uint8_t t_skip2a(uint8_t a, uint8_t, uint8_t *p);
uint8_t t_skip2b(uint8_t a, uint8_t, uint8_t *p);
uint8_t t_and(uint8_t a, uint8_t b);
uint8_t t_or(uint8_t a, uint8_t b);
uint8_t t_eor(uint8_t a, uint8_t b);

int16_t t_cpc(int16_t a, int16_t *p);

uint8_t buf[2];
int16_t bufi[2] ={ 1, 0 };

int main() {
	
	t_skip1a(0xff, buf);
	t_skip1a(0x00, buf);
	t_skip1b(0xff, buf);
	t_skip1b(0x00, buf);
	t_skip2a(1,1, buf);
	t_skip2a(1,2, buf);
	t_skip2b(1,1, buf);
	t_skip2b(1,2, buf);
	t_and(1, 0);
	t_and(0, 1);
	t_and(1, 1);
	t_and(0, 0);
	t_or(1, 0);
	t_or(0, 1);
	t_or(1, 1);
	t_or(0, 0);
	t_eor(1, 0);
	t_eor(0, 1);
	t_eor(1, 1);
	t_eor(0, 0);
	t_cpc(0, bufi);
	t_cpc(1, bufi);
	t_cpc(2, bufi);
	t_cpc(4, bufi);
	sleep();
	return 0;
}
